#!/bin/bash
# Script utilisé pour "automatiser" (raccourcir) le processus de pull, d'ajout, de commit et de push pour le répositoire Gitea personnel.
# Ajout de messages et de délais pour mieux se repérer et se situer dans le processus.
# Ajout d'un système de choix
# Ajout d'un export de proxy HTTP/HTTPS automatique vers ceux du lycée pour la machine en salle 214.
# Ajout d'un système de gestion d'erreur très basique pour éviter qu'un push/un pull se produise en cas de réponses incorrectes.

export http_proxy="http://10.121.38.1:8080/"
export https_proxy="http://10.121.38.1:8080/"

echo "Voulez-vous récupérer les fichiers du dépôt ou effectuer un push sur le dépôt ? [1 = Pull, 2 = Push]"
read answer

echo "Quelle branche est concernée ? [1 = main, 2 = test]"
read branch

if [ $branch == 1 ] ; then
	if [ $answer == 1 ] ; then
		git checkout main
		echo "Récupération des fichiers à jour, branche main..."
		git pull -q origin main
	else
		git checkout main
		echo "Ajout des fichiers au Gitea..."
		sleep 1
		git add .
		echo "Commit en cours..."
		sleep 1
		git commit
		echo "Entrez la version du tag:"
		read tag
		git tag $tag
		echo "Push des fichiers au Gitea, branche main..."
		sleep 1
		git push -q origin main --tag
	fi

elif [ $branch == 2 ] ; then
	if [ $answer == 1 ] ; then
		git checkout test
		echo "Récupération des fichiers à jour dans la branche test..."
		git pull -q origin test
	else
		git checkout test
		echo "Ajout des fichiers au Gitea, branche test..."
		sleep 1
		git add .
		echo "Commit en cours..."
		sleep 1
		git commit
		echo "Entrez la version du tag:"
		read tag
		git tag $tag
		echo "Push des fichiers au Gitea, branche test..."
		sleep 1
		git push -q origin test --tag
	fi

else
	echo "Choisissez une branche et une option valide. Veuillez relancer le script"

fi